SystemOrganization addCategory: #'Ma Armored Code-API'!
SystemOrganization addCategory: #'Ma Armored Code-Exceptions'!
SystemOrganization addCategory: #'Ma Armored Code-Info'!
SystemOrganization addCategory: #'Ma Armored Code-Network testing'!
SystemOrganization addCategory: #'Ma Armored Code-SUnit extensions'!
SystemOrganization addCategory: #'Ma Armored Code-private'!

MaObject subclass: #MaNetworkTestPlayer
	instanceVariableNames: 'testCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-Network testing'!

!MaNetworkTestPlayer class methodsFor: 'as yet unclassified' stamp: 'cmm 5/6/2002 22:40'!
listenInNewImageOnPort: anInteger
	"Launch a new image on this machine, when the image starts, it should automatically be listeningon port anInteger."

"not implemented yet, for now, you'll have to start them yourself.."
! !

!MaNetworkTestPlayer class methodsFor: 'as yet unclassified' stamp: 'cmm 7/2/2002 00:13'!
testCaseClass: aNetworkTestCaseClass

	^self new 
		setTestCaseClass: aNetworkTestCaseClass;
		yourself! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 6/7/2004 23:53'!
loadCodeFrom: aPositionableStream

	aPositionableStream position: 0.
	aPositionableStream 
		maFileInAnnouncing: 'loading code from conductor..' 
		logged: false! !

!MaNetworkTestPlayer methodsFor: 'request framework requirements' stamp: 'cmm 6/22/2004 10:37'!
processRequest: aMaNetworkTestPlayerRequest

	| result |
	self maMarked: 'magic'.  "This method called as part of test-script user-setup.  See MagmaTesterPackageInfo>>#readmeText."
	MaArmoredCodeNotification signal: 'Processing ', aMaNetworkTestPlayerRequest printString.
	result _ aMaNetworkTestPlayerRequest processFor: self.
	^ result == testCase ifFalse: [ result ]! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 10/30/2004 17:27'!
protocol

	^ testCase playerProtocol! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 6/7/2004 21:55'!
remoteEvaluate: aString

	| result |
	result _ 
		Compiler
	
		evaluate: aString
	
		for: testCase
	
		logged: false.
	^ (result == testCase or: [ result == self ])
		ifTrue: [ nil ]
		ifFalse: [ result ]! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 6/7/2004 21:55'!
remotePerform: selector withArguments: anArray

	| result |
	result _ testCase
		perform: selector
		withArguments: anArray.
	^ (result == testCase or: [ result == self ])
		ifTrue: [ nil ]
		ifFalse: [ result ]! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 6/6/2004 13:24'!
setTestCaseClass: aClass

	testCase _ aClass new! !

MaObject subclass: #MaNetworkTestPlayerFacade
	instanceVariableNames: 'link name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaNetworkTestPlayerFacade class methodsFor: 'creation' stamp: 'cmm 10/8/2002 22:04'!
hostAddress: aByteArray port: anInteger

	^self new link:
		(MaTcpRequestServerLink
			hostAddress: aByteArray
			port: anInteger)
! !

!MaNetworkTestPlayerFacade class methodsFor: 'creation' stamp: 'cmm 10/8/2002 22:04'!
name: aString hostAddress: aByteArray port: anInteger

	^self new 
		name: aString;
		link:
			(MaTcpRequestServerLink
				hostAddress: aByteArray
				port: anInteger)
! !

!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 5/2/2002 23:58'!
connect

	link connect
! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 5/9/2002 23:01'!
hostAddress

	^link hostAddress! !

!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 4/27/2002 14:50'!
link: aMaServerLink

	link _ aMaServerLink! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 5/22/2002 10:21'!
name

	^name
! !

!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 5/8/2002 22:00'!
name: aString

	name _ aString! !

!MaNetworkTestPlayerFacade methodsFor: 'private' stamp: 'cmm 5/22/2002 17:32'!
pushClass: aClass

	| stream |
	stream _ ReadWriteStream on: String new.
	aClass
		fileOutOn: stream
		moveSource: false
		toFile: 0.
	^self pushCode: stream
! !

!MaNetworkTestPlayerFacade methodsFor: 'private' stamp: 'cmm 3/21/2003 00:55'!
pushCode: aPositionableStream

	MaArmoredCodeNotification signal: 'pushing code to ', name.
	^self submit:
		(MaPushCodeRequest new
			stream: aPositionableStream;
			yourself)! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 3/21/2003 00:55'!
remoteEvaluate: aString

	MaArmoredCodeNotification
		signal: (String streamContents:
			[ :stream |
			stream
				nextPutAll: name;
				nextPutAll: ' is remote evaluating: ';
				cr; tab;
				nextPutAll: aString ]).
	^self submit:
		(MaRemoteEvaluateRequest new
			codeString: aString;
			yourself)
! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 3/21/2003 00:55'!
remotePerform: selectorSymbol withArguments: anArray

	MaArmoredCodeNotification signal: 'remote performing ', selectorSymbol, ' with arguments ', anArray printString, ' in ', name.
	^self submit:
		(MaRemotePerformRequest new
			selector: selectorSymbol;
			arguments: anArray)! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 3/21/2003 00:55'!
setTestCaseClass: aClass
	"Make sure you have first updated the ChangeSet that contains your test case class, or the player may not be able to instantiate it."

	MaArmoredCodeNotification signal: 'setting test case class to ', aClass name, ' in ', name.
	^self submit:
		(MaSetTestCaseClassRequest new
			testCaseClass: aClass;
			yourself)
! !

!MaNetworkTestPlayerFacade methodsFor: 'private' stamp: 'cmm 1/2/2003 14:46'!
submit: aMaNetworkTestPlayerRequest

	| result |
	result _ link submit: aMaNetworkTestPlayerRequest.
	result maIsException 
		ifTrue: [ result class signal: result messageText ]
		ifFalse: [ ^result ]! !

!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 10/16/2002 17:04'!
timeoutSeconds: anInteger

	link timeoutSeconds: anInteger! !

MaObject subclass: #MaNetworkTestPlayerRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaNetworkTestPlayerRequest methodsFor: 'as yet unclassified' stamp: 'cmm 12/23/2002 17:42'!
processFor: aMaNetworkTestPlayer

	self subclassResponsibility! !

MaNetworkTestPlayerRequest subclass: #MaPushCodeRequest
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaPushCodeRequest methodsFor: 'private' stamp: 'cmm 6/7/2004 23:53'!
processFor: aMaNetworkTestPlayer

	aMaNetworkTestPlayer loadCodeFrom: self stream.
	^ nil! !

!MaPushCodeRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:16'!
stream

	^stream
! !

!MaPushCodeRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:16'!
stream: aPositionableStream

	stream _ aPositionableStream! !

MaNetworkTestPlayerRequest subclass: #MaRemoteEvaluateRequest
	instanceVariableNames: 'codeString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaRemoteEvaluateRequest methodsFor: 'accessing' stamp: 'cmm 5/12/2002 21:32'!
codeString

	^codeString
! !

!MaRemoteEvaluateRequest methodsFor: 'accessing' stamp: 'cmm 5/12/2002 21:32'!
codeString: aString

	codeString _ aString! !

!MaRemoteEvaluateRequest methodsFor: 'accessing' stamp: 'cmm 5/12/2002 21:37'!
processFor: aMaNetworkTestPlayer

	^aMaNetworkTestPlayer remoteEvaluate: codeString! !

MaNetworkTestPlayerRequest subclass: #MaRemotePerformRequest
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 5/6/2002 23:28'!
arguments

	^arguments
! !

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 5/6/2002 23:28'!
arguments: aSymbol

	arguments _ aSymbol
! !

!MaRemotePerformRequest methodsFor: 'private' stamp: 'cmm 4/27/2002 16:33'!
processFor: aMaNetworkTestPlayer

	^aMaNetworkTestPlayer
		remotePerform: self selector
		withArguments: self arguments
! !

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:07'!
selector

	^selector
! !

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:07'!
selector: aSymbol

	selector _ aSymbol
! !

MaNetworkTestPlayerRequest subclass: #MaSetTestCaseClassRequest
	instanceVariableNames: 'testCaseClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaSetTestCaseClassRequest methodsFor: 'private' stamp: 'cmm 6/7/2004 23:59'!
processFor: aMaNetworkTestPlayer

	aMaNetworkTestPlayer setTestCaseClass: self testCaseClass.
	^ nil! !

!MaSetTestCaseClassRequest methodsFor: 'accessing' stamp: 'cmm 5/27/2002 20:15'!
testCaseClass

	^testCaseClass! !

!MaSetTestCaseClassRequest methodsFor: 'accessing' stamp: 'cmm 5/27/2002 20:15'!
testCaseClass: aClass

	testCaseClass _ aClass! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:39'!
maDebug

	self maRunUsing: #maDebug:
! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:43'!
maDebugAsFailure

	self maRunUsing: #maDebugAsFailure:
! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:42'!
maDebugAsFailure: aResult 

	self
		maExecuteTestsUsing: #maDebugAsFailure:
		result: aResult
! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:41'!
maDebug: aResult 

	self
		maExecuteTestsUsing: #maDebug:
		result: aResult
! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 5/27/2002 19:07'!
maExecuteTestsUsing: aSymbol result: aResult

	self maMarked: 'dev'.
"I couldn't figure out how 'resources' was meant to be used with regard to TestSuites.  I definitely need to maintain testing resources for Magma, but SUnit's implementation with regard to resources seems incomplete.  That's why the only way to properly test Magma is 'MagmaTestCase suite maDebug'."
	self tests isEmpty ifTrue: [ ^self ].
	[ self tests first class setUpSuite.
	self tests do: 
		[:each | 
		self sunitChanged: each.
		each
			perform: aSymbol
			with: aResult ] ] ensure: [ self tests first class tearDownSuite ]
! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 9/1/2003 15:51'!
maRunUsing: aSymbol

	| result |
	result := TestResult new.
	[ self 
		perform: aSymbol 
		with: result ] 
			sunitEnsure: [self resources do: [:each | each reset ] ].
	^result
! !

MaNotification subclass: #MaArmoredCodeNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-Exceptions'!

!TestResult methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:56'!
maDebugCaseAsFailure: aTestCase

	aTestCase halt runCase.
	self passed add: aTestCase
! !

!TestResult methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:54'!
maDebugCase: aTestCase

	aTestCase runCase.
	self passed add: aTestCase
! !

PackageInfo subclass: #MaArmoredCodePackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-Info'!

!MaArmoredCodePackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 2/2/2003 12:13'!
prerequisitePackages

	^#('Ma client server')! !

TestCase subclass: #MaTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-SUnit extensions'!

!MaTestCase commentStamp: '<historical>' prior: 0!
Getting ready to try using "fixtureSpecs" so we can test against hundreds of fixtures easily.
!

MaTestCase subclass: #MaNetworkTestCase
	instanceVariableNames: ''
	classVariableNames: 'NextPort'
	poolDictionaries: ''
	category: 'Ma Armored Code-Network testing'!

MaNetworkTestCase class
	instanceVariableNames: 'currentPlayers'!

!MaNetworkTestCase commentStamp: '<historical>' prior: 0!
My subclasses are intended to test network programs.  I provide methods for communicating with other images and tunnelling requests to them.!

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 6/4/2002 23:08'!
addPlayerNamed: aString

	self
		addPlayerNamed: aString
		at: (self getAddressFor: aString)
		port: self getNextPort
! !

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 2/9/2005 17:23'!
addPlayerNamed: aString at: hostAddressByteArray port: anInteger
	"The player must first be running and listening on port anInteger."

	self currentPlayers
		at: aString
		put: 
			(MaNetworkTestPlayerFacade
				name: aString
				hostAddress: hostAddressByteArray
				port: anInteger) connect.
	MaClientServerPreferences debug: true.
	(self playerNamed: aString) timeoutSeconds: 172800  "2 days"! !

!MaNetworkTestCase class methodsFor: 'private' stamp: 'cmm 5/1/2003 16:17'!
currentPlayers
	"We need to rename this variable.  But Squeak appears to have a bug that prevents from recompiling the metaclass."

	^currentPlayers
! !

!MaNetworkTestCase class methodsFor: 'private' stamp: 'cmm 5/1/2003 16:17'!
currentPlayers: aDictionary
	"key = player name, value = aMaNetworkTestPlayerFacade"

	currentPlayers _ aDictionary! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 10/7/2004 16:35'!
getAddressFor: playerName

^ #(127 0 0 1) asByteArray

"Commenting out this old code to allow for one-click run of the Magma test cases."
"
	^(self players includesKey: playerName)
		ifTrue:
			[ (self playerNamed: playerName) hostAddress ]
		ifFalse:
			[ NetNameResolver addressFromString: 
				(FillInTheBlank 
					request: 'Enter the address of ', playerName
					initialAnswer: '127.0.0.1') ]"! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 5/27/2002 15:16'!
getNextPort

	^NextPort _ NextPort + 1
! !

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 5/27/2002 15:27'!
initializeNextPort

	NextPort _ 1313
! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 5/27/2002 19:34'!
playerNamed: aString

	^self players at: aString
! !

!MaNetworkTestCase class methodsFor: 'private' stamp: 'cmm 5/27/2002 19:36'!
players

	^self currentPlayers
! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 5/27/2002 19:35'!
playersDo: aBlock

	self players do: aBlock! !

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 1/3/2003 00:28'!
removePlayerNamed: aString

	self currentPlayers removeKey: aString! !

!MaNetworkTestCase class methodsFor: 'framework' stamp: 'cmm 5/27/2002 15:24'!
setUpSuite

	super setUpSuite.
	self 
		currentPlayers: Dictionary new;
		initializeNextPort
! !

!MaNetworkTestCase class methodsFor: 'framework' stamp: 'cmm 5/27/2002 15:58'!
tearDownSuite
	"Since a network test suite runs across multiple machines, players images are set up and torn down manually."
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 8/8/2002 18:32'!
getAddressFor: playerName

	^self class getAddressFor: playerName! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/27/2002 19:32'!
playerNamed: aString

	^self class playerNamed: aString
! !

!MaNetworkTestCase methodsFor: 'accessing' stamp: 'cmm 10/30/2004 17:26'!
playerProtocol

	^ MaNetworkTestPlayerRequest allSubclasses
		add: UndefinedObject ;
		yourself! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/27/2002 19:33'!
playersDo: aBlock

	self class playersDo: aBlock! !

!MaNetworkTestCase methodsFor: 'printing' stamp: 'cmm 5/3/2002 00:12'!
printOn: aStream

	testSelector
		ifNil: [ aStream nextPutAll: 'a', self class name ]
		ifNotNil: [ super printOn: aStream ]
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/1/2003 17:12'!
pushClass: aClass

	self playersDo: [ :each | each pushClass: aClass ]! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/27/2002 22:44'!
pushClass: aClass to: playerNameString

	(self playerNamed: playerNameString) pushClass: aClass
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/12/2002 21:48'!
remoteEvaluate: codeString in: playerName

	^(self playerNamed: playerName) remoteEvaluate: codeString
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/7/2002 22:56'!
remotePerform: selectorSymbol in: playerName

	^(self playerNamed: playerName)
		remotePerform: selectorSymbol
		withArguments: Array new! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/8/2002 21:54'!
remotePerform: selectorSymbol withArguments: anArray in: playerName

	^(self playerNamed: playerName)
		remotePerform: selectorSymbol
		withArguments: anArray! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/8/2002 21:54'!
remotePerform: selectorSymbol with: arg1 in: playerName

	^(self playerNamed: playerName)
		remotePerform: selectorSymbol
		withArguments: (Array with: arg1)
! !

!MaTestCase class methodsFor: 'creation' stamp: 'cmm 4/17/2002 23:40'!
new

	^super new initialize
! !

!MaTestCase class methodsFor: 'framework' stamp: 'cmm 5/27/2002 14:47'!
setUpSuite
	"Subclasses may implement general set-up code for 
	that should only run once for all tests.  For example,
	network tests maintain a connection to other machines
	that participate in the test.  The facades to these other
	machines needs to be maintained."
! !

!MaTestCase class methodsFor: 'testing' stamp: 'cmm 4/18/2002 00:11'!
shouldInheritSelectors

	^false! !

!MaTestCase class methodsFor: 'framework' stamp: 'cmm 4/8/2005 13:05'!
tearDownSuite
	"Counterpart to setUpSuite.  See that method for
	more info."

	Transcript cr; show: 'Tests complete.  Tearing down suite..'! !

!MaTestCase methodsFor: 'file management' stamp: 'cmm 12/5/2002 23:11'!
deleteFilesNamed: aCollection

	aCollection do:
		[ :each |
		StandardFileStream allInstances do:
			[ :eachStream |
			eachStream fullName = each ifTrue:
				[ self notify: 'closing a rogue FileStream for ', eachStream fullName.
				eachStream close ] ].
		self notify: 'deleting file ', each.
		(FileDirectory forFileName: each) deleteFileNamed: each ]! !

!MaTestCase methodsFor: 'file management' stamp: 'cmm 3/21/2003 00:57'!
deleteFilesWhere: oneArgBlock
	"oneArgBlock takes the filename of each file in the environmentPath (see MaArmoredCodeOptions).."

	| fd filenames |

	filenames _ (fd _ FileDirectory on: self environmentPath) fileNames.
	StandardFileStream allInstances do:
		[ :eachStream |
		(filenames includes: eachStream fullName) ifTrue:
			[ MaArmoredCodeNotification signal: 'closing a rogue FileStream for ', eachStream fullName.
			eachStream close ] ].
	filenames do:
		[ :each |
		(oneArgBlock value: each)
			ifTrue:
				[ MaArmoredCodeNotification signal: 'closing rogue filestreams on ', each.
				StandardFileStream allInstances do: 
					[ :eachStream | 
					eachStream fullName = each ifTrue: [ eachStream close ] ].
				MaArmoredCodeNotification signal: 'removing ', each.
				fd deleteFileNamed: each ] ]! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 9/24/2004 17:13'!
environmentDirectory

	^ MaArmoredCodeOptions current testEnvironmentDirectory! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 10/7/2004 16:59'!
environmentPath

	^ self environmentDirectory pathName! !

!MaTestCase methodsFor: 'initializing' stamp: 'cmm 4/17/2002 23:50'!
initialize

	"nothing to do yet.."
! !

!MaTestCase methodsFor: 'running' stamp: 'cmm 4/18/2002 00:56'!
maDebugAsFailure: aTestResult

	aTestResult maDebugCaseAsFailure: self
! !

!MaTestCase methodsFor: 'running' stamp: 'cmm 4/18/2002 00:54'!
maDebug: aTestResult

	aTestResult maDebugCase: self
! !

!MaTestCase methodsFor: 'private' stamp: 'cmm 3/21/2003 00:57'!
notify: aString

	MaArmoredCodeNotification signal: MaCalendarTime now time printString, ':  ', aString! !

!MaTestCase methodsFor: 'private' stamp: 'cmm 9/14/2004 12:50'!
performTest

	[ self
		notify: 'running ', self selector, '.. ';
		notify: 'time to run ', self selector, ':  ', [ super performTest ] maCalendarTimeToRun maAbbreviatedString ]

		on: MaNotification
		do:
			[ :n | Transcript cr; show: n messageText.
			n resume ]! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 10/7/2004 17:13'!
projectDirectory
	"The projectDirectory typically resides in the projectsDirectory, with my subclasses typically appending their project name to the projectsDirectory."

	self subclassResponsibility! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 10/7/2004 17:27'!
projectsDirectory

	^ (FileDirectory default directoryExists: 'My projects')
		ifTrue:
			[ FileDirectory on: (FileDirectory default fullNameFor: 'My projects') ]
		ifFalse:
			[ FileDirectory default ]! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 10/7/2004 17:26'!
resourcesDirectory

	^ (self projectDirectory directoryExists: 'Resources')
		ifTrue:
			[ FileDirectory on: (self projectDirectory fullNameFor: 'Resources') ]
		ifFalse: [ self projectDirectory ]! !

MaSingleton subclass: #MaArmoredCodeOptions
	instanceVariableNames: 'testEnvironmentDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-API'!

!MaArmoredCodeOptions class methodsFor: 'initializing' stamp: 'cmm 10/6/2004 16:40'!
initialize

	self reset! !

!MaArmoredCodeOptions methodsFor: 'accessing' stamp: 'cmm 9/24/2004 17:11'!
testEnvironmentDirectory

	^testEnvironmentDirectory! !

!MaArmoredCodeOptions methodsFor: 'accessing' stamp: 'cmm 10/7/2004 21:36'!
testEnvironmentDirectory: aFileDirectory

	testEnvironmentDirectory _ aFileDirectory! !

!MaArmoredCodeOptions methodsFor: 'accessing' stamp: 'cmm 10/7/2004 21:36'!
testEnvironmentPath: pathString

	self testEnvironmentDirectory: (FileDirectory on: pathString)! !
MaArmoredCodeOptions initialize!
